#include <app/Application.h>
#include <interface/Window.h>
#include <interface/View.h>
#include <interface/TabView.h>

#include <stdio.h>

class TestTabViewHello : public BView {
	
	public:
		TestTabViewHello(BRect aFrame, char *aName);
		virtual void Draw(BRect aUpdateRect);
};

TestTabViewHello :: TestTabViewHello(BRect aFrame, char *aName)
				 : BView(aFrame, aName, B_FOLLOW_ALL, B_WILL_DRAW) {
}

void TestTabViewHello :: Draw(BRect aUpdateRect) {
	
	printf("Draw\n");
	MovePenTo(BPoint(10, 30));
	DrawString("Hello world!");
	
}

class TestTabViewWindow : public BWindow {
	
	private:
		BTab * tab;
		BTabView * tabView;
	
	public:
		TestTabViewWindow(BRect aFrame);
		bool QuitRequested();
	
};

TestTabViewWindow :: TestTabViewWindow(BRect aFrame)
				  : BWindow(
				  		aFrame,
				  		"TestTabViewWindow",
				  		B_TITLED_WINDOW,
				  		0) {

	BRect frame = Bounds();
	frame.InsetBy(5, 5);

	tabView = new BTabView(frame, "TestTabViewTabView");
	tab = new BTab();
	frame = tabView->Bounds();
	frame.InsetBy(5, 5);
	TestTabViewHello * view = new TestTabViewHello(
		frame,
		"TestTabViewHello");
	tabView->AddTab(NULL, tab);
	AddChild(tabView);
	
	tab->SetView(view);
	tab->SetLabel("Hello World");
	tabView->Select(tabView->Selection());

}

bool TestTabViewWindow :: QuitRequested() {
	
	be_app->PostMessage(B_QUIT_REQUESTED);
	
	return true;
	
}

class TestTabViewApp : public BApplication {

	private:
		TestTabViewWindow * window;
		
	public:
		TestTabViewApp();
	
};

TestTabViewApp :: TestTabViewApp()
			   : BApplication("application/x-vnd.ElegantLabs-TestTabViewApp") {

	BRect rect(100, 100, 400, 400);
	window = new TestTabViewWindow(rect);
	window->Show();

}

int main() {
	
	TestTabViewApp myApp;
	myApp.Run();
	
	return 0;
	
}
